# NOTE: Derived from blib/lib/Ace/Object.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Ace::Object;

#line 1570 "blib/lib/Ace/Object.pm (autosplit into blib/lib/auto/Ace/Object/asGif.al)"
# run a series of GIF commands and return the Gif and the semi-parsed
# "boxes" structure.  Commands is typically a series of mouseclicks
# ($gif,$boxes) = $aceObject->asGif(-clicks=>[[$x1,$y1],[$x2,$y2]...],
#                                   -dimensions=>[$x,$y]);
sub asGif {
  my $self = shift;
  my ($clicks,$dimensions,$display) = rearrange(['CLICKS',
						 ['DIMENSIONS','DIM'],
						 'DISPLAY'],@_);
  $display = "-D $display" if $display;
  my @commands = "gif display $display @{[$self->class]} \"@{[$self->name]}\"";
  push(@commands,"Dimensions @$dimensions") if ref($dimensions);
  push(@commands,map { "mouseclick @{$_}" } @$clicks) if ref($clicks);
  push(@commands,"gifdump -");
  
  # do the query
  my $data = $self->{'db'}->raw_query(join(' ; ',@commands));

  # did this query succeed?
  return unless $data=~m!^// (\d+) bytes\n!m;
  my $bytes = $1;
  my $trim = $';  # everything after the match
  my $gif = substr($trim,0,$bytes);
  
  # now process the boxes
  my @b;
  my @boxes = split("\n",substr($trim,$bytes));
  foreach (@boxes) {
    last if m!^//!;
    chomp;
    my ($left,$top,$right,$bottom,$class,$name,$comments) = 
      m/^\s*\d*\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\w+):"(.+)"\s*(.*)/;
    next unless defined $left;
    $comments=~s/\s+$//; # sometimes there's extra white space at the end
    my $box = {'coordinates'=>[$left,$top,$right,$bottom],
	       'class'=>$class,
	       'name' =>$name,
	       'comment'=>$comments};
    push (@b,$box);
  }
  return ($gif,\@b);
}

# end of Ace::Object::asGif
1;
